<template>
    <form class="form"
          novalidate
          @submit.prevent="handleSubmit"
          enctype="multipart/form-data">
        <div>
            <p class="instruction">Faites un glisser-déposer du groupe de destinataires souhaités dans la colonne "Destinataires choisis".</p>
        </div>
        
        <FormRow>
            <div class="draggable-column">
                <h2>Destinataires possibles</h2>
                <draggable class="list-group"
                           :list="possibleRecipients"
                           group="people"
                           @change="log"
                           itemKey="name">
                    <template #item="{ element }">
                        <div class="card list-group-item" :class="{ 'not-draggable': !enabled }">
                            {{ element.name }}
                            <template v-if="element.lot">
                                - {{ element.lot }}
                            </template>
                        </div>
                    </template>
                </draggable>

            </div>
            <div class="draggable-column">
                <h2>Destinataires choisis</h2>

                <draggable class="list-group"
                           :list="recipients"
                           group="people"
                           @change="log"
                           itemKey="name">
                    <template #item="{ element }">
                        <div class="card list-group-item" :class="{ 'not-draggable': !enabled }">
                            {{ element.name }}
                            <template v-if="element.lot">
                                - {{ element.lot }}
                            </template>
                        </div>
                    </template>
                </draggable>

            </div>
        </FormRow>


        <FormInput v-model="mailing.subject"
                   type="text"
                   name="subject"
                   :ref="addFormInputRef"
                   :label="t('user.mailing.subject')"
                   @validated="handleValidation" />
        <FormTextEditor v-model="mailing.message"
                        :ref="addFormInputRef"
                        name="message"
                        :label="t('user.mailing.message')"
                        @validated="handleValidation" />
        <button class="form__submit btn btn--fullscreen" type="submit">
            {{ t('user.mailing.send') }}
        </button>
    </form>
</template>

<script lang="ts" setup>
    import FormRow from "@/components/forms/FormRow.vue"
    import FormInput from "@/components/forms/FormInput.vue"
    import FormTextEditor from "@/components/forms/FormTextEditor.vue"
    import { computed, onMounted, ref } from "vue";
    import { useI18n } from "vue3-i18n";
    import { notifyError } from "@/notify";
    import { Mailing } from "@/types/entities/mailing";
    import { useMailingService } from "@/inversify.config";
    import draggable from 'vuedraggable';
    import { Member } from "../../types";
    import { WaitingMember } from "../../types/entities/waitingMember";
    import { defineEmits } from 'vue';
    import { Status } from "@/validation"

    const { t } = useI18n();
    const emit = defineEmits(['formSubmit']);
    const mailingService = useMailingService();

    const formInputs = ref<any[]>([])
    const inputValidationStatuses: any = {}

    const mailing = ref<Mailing>({
        recipients: [],
        subject: "",
        message: "",
    });

    const possibleRecipients = ref([
        { name: "Tous les membres" },
        { name: "Toutes les personnes en attente" },
    ]);
    const recipients = ref<string[]>([]);

    const possibleRecipientsMembers = ref<Member[]>();
    const possibleRecipientsWaitingMembers = ref<WaitingMember[]>();
    const selectedRecipients = ref<string[]>([]);

    const membersAreLoading = ref(false);

    const handleSubmit = () => {
        mailing.value.recipients = [...selectedRecipients.value];
        console.log(mailing)
        formInputs.value.forEach((x: typeof FormInput) => x.validateInput())
        if (Object.values(inputValidationStatuses).some(x => x === false)) {
            notifyError(t('global.formErrorNotification'))
            return
        }
        if (selectedRecipients.value.length === 0) {
            notifyError(t('user.mailing.errorNoRecipient'))
            return;
        }

        emit('formSubmit', mailing.value)
    };

    const isValidEmail = (email: string) => {
        if (!email)
            return false;

        const emailRegex = /^[^\s@]+@[^\s@]+\.[^\s@]+$/;
        return emailRegex.test(email);
    }

    const handleValidation = () => {
        // Validation
    };

    const handdleDragg = (evt: any) => {
        console.log(evt)
    }

    const log = (evt: any) => {

        const movedItem: any = evt.removed ? evt.removed.element : null;
        console.log(evt.removed.element.name);

        if (movedItem) {
            if (movedItem.name === "Tous les membres") {
                if (possibleRecipientsMembers.value) {
                    handleRecipients(possibleRecipientsMembers.value);
                }
            } else if (movedItem.name === "Toutes les personnes en attente") {
                if (possibleRecipientsWaitingMembers.value) {
                    handleRecipients(possibleRecipientsWaitingMembers.value);
                }
            }
        }
    }

    const handleRecipients = (recipientsList: any[]) => {
        if (!recipientsList || recipientsList.length === 0) {
            recipientsList.forEach(recipient => {
                if (recipient.email && !selectedRecipients.value.includes(recipient.email)) {
                    selectedRecipients.value.push(recipient.email);
                }
            });
        } else {
            const emailsToAdd = recipientsList.filter(recipient => recipient.email && !selectedRecipients.value.includes(recipient.email));
            const emailsToRemove = selectedRecipients.value.filter(email => recipientsList.some(recipient => recipient.email === email));

            emailsToAdd.forEach(recipient => {
                if (!selectedRecipients.value.includes(recipient.email)) {
                    selectedRecipients.value.push(recipient.email);
                }
            });

            emailsToRemove.forEach(email => {
                const index = selectedRecipients.value.indexOf(email);
                if (index > -1) {
                    selectedRecipients.value.splice(index, 1);
                }
            });
        }
        console.log(selectedRecipients.value)
        console.log(recipients.value)
    };

    onMounted(async () => {
        await loadAllMembersAndWaitingMembers();
    });

    async function loadAllMembersAndWaitingMembers() {
        membersAreLoading.value = true;

        let { members, waitingMembers } = await mailingService.getMembersAndWaitingMembers();

        console.log(members)
        if (members && members.length > 0) {
            members = members.filter(member => member.lots && member.lots.length > 0);
            possibleRecipientsMembers.value = members
        }

        console.log(waitingMembers)
        if (waitingMembers && waitingMembers.length > 0) {
            possibleRecipientsWaitingMembers.value = waitingMembers
        }

        membersAreLoading.value = false;
    }

    const addFormInputRef = ref(null);
    const enabled = true;
</script>

<style scoped>
    .draggable-column {
        border: 1px solid #ccc;
        border-radius: 8px;
        padding: 10px;
        margin-bottom: 20px;
    }

    h2 {
        padding-bottom: 10px;
    }

    .card {
        background-color: #ffffff;
        border-radius: 8px;
        padding: 10px;
        margin-bottom: 10px;
        cursor: move;
    }

    .not-draggable {
        cursor: not-allowed;
    }

    .instruction {
        font-size: 14px;
        color: #555;
        margin-top: 2rem;
        margin-bottom: 1rem;
    }
</style>

